PID_FOLDER := /var/run/inboxen
PYTHON=python

PYTHON_VERSION = 3.12
PYTHON_OK = $(shell $(PYTHON) -c 'import sys;print(int(float("%d.%d"% sys.version_info[0:2]) == $(PYTHON_VERSION)))')
ifeq ($(PYTHON_OK),0)
  $(error "Python $(PYTHON_VERSION) is required for this project")
endif

##
# Dev
##

# this rule should be the default
.PHONY: dev-setup
dev-setup: install-dev-deps
	mkdir -p logs run
	$(MAKE) static
	./manage.py
	./manage.py migrate
	touch inboxen/wsgi.py
	echo "You're now set for Inboxen development."
	echo "If you require salmon, run 'make salmon-start'"
	echo "If you require celery, run 'make celery-start'"

.PHONY: install-dev-deps
install-dev-deps: install-dev-py-deps install-js-deps

.PHONY: install-dev-py-deps
install-dev-py-deps:
	pip-sync requirements-dev.txt || pip install -r requirements-dev.txt

.PHONY: install-js-deps
install-js-deps:
	npm install --no-save

.PHONY: tests-py
tests-py: install-dev-deps
	DJANGO_SETTINGS_MODULE=inboxen.tests.settings $(MAKE) static
	./manage.py test --noinput --parallel=$(shell nproc)

.PHONY: tests-py-coverage
tests-py-coverage: install-dev-deps
	DJANGO_SETTINGS_MODULE=inboxen.tests.settings $(MAKE) static
	pip install coverage
	coverage run --branch ./manage.py test
	coverage report
	coverage html
	coverage xml

.PHONY: tests-js
tests-js: install-dev-deps
	CHROMIUM_BIN=$(shell which chrome || which chromium-browser) npx grunt tests

##
# Update requirements
##

.PHONY: udpate-requirements
update-requirements: update-py-requirements update-js-requirements

.PHONY: update-py-requirements
update-py-requirements:
	pip-compile -U -o requirements.txt inboxen/data/requirements.in
	pip-compile -U -o requirements-dev.txt requirements-dev.in
	pip-compile -U -o extra/requirements/cantaloupe.inboxen.org.txt extra/requirements/cantaloupe.inboxen.org.in

.PHONY: new-py-requirements
new-py-requirements:
	pip-compile -o requirements.txt inboxen/data/requirements.in
	pip-compile -o requirements-dev.txt requirements-dev.in
	pip-compile -o extra/requirements/cantaloupe.inboxen.org.txt extra/requirements/cantaloupe.inboxen.org.in

.PHONY: update-js-requirements
update-js-requirements:
	npm update
	npm audit fix

##
# Static assets
##

.PHONY: static
static:
	npx grunt
	./manage.py compilemessages
	./manage.py collectstatic --clear --noinput

##
# Daemon control
##

.PHONY: celery-stop
celery-stop:
	-kill `cat $(PID_FOLDER)/worker.pid`
	-kill `cat $(PID_FOLDER)/beat.pid`
	sleep 5
	test ! -f $(PID_FOLDER)/worker.pid
	test ! -f $(PID_FOLDER)/beat.pid


.PHONY: celery-start
celery-start:
	DJANGO_SETTINGS_MODULE=inboxen.settings celery -A inboxen worker -l warning --events --detach -Ofair -f logs/celery-worker.log --pidfile $(PID_FOLDER)/worker.pid
	DJANGO_SETTINGS_MODULE=inboxen.settings celery -A inboxen beat -l warning --detach -f logs/celery-beat.log --pidfile $(PID_FOLDER)/beat.pid

.PHONY: salmon-stop
salmon-stop:
	-SALMON_SETTINGS_MODULE=inboxen.router.config.settings salmon stop --pid $(PID_FOLDER)/router.pid
	sleep 5
	test ! -f $(PID_FOLDER)/router.pid

.PHONY: salmon-start
salmon-start:
	SALMON_SETTINGS_MODULE=inboxen.router.config.settings salmon start --pid $(PID_FOLDER)/router.pid --boot inboxen.router.config.boot
	sleep 5
	SALMON_SETTINGS_MODULE=inboxen.router.config.settings salmon status --pid $(PID_FOLDER)/router.pid

##
# Includes
##

include extra/makefiles/cantaloupe.mk
include extra/makefiles/common.mk
-include local.mk
